use strict;
use warnings 'all';

package SoMat::eDAQ::Discovery;
use Socket;

sub discover_edaqs {
    open(FH, "</etc/HOSTIP") or die "Can't open /etc/HOSTIP";
    my $hostip = <FH>;
    close(FH);
    my $iaddr = inet_aton("$hostip\n");
    my $proto = getprotobyname('udp');
    my $port = 7734;
    my $paddr = sockaddr_in(0, $iaddr); # 0 means let kernel pick

    socket(SOCKET, PF_INET, SOCK_DGRAM, $proto) or die "socket: $!";
    bind(SOCKET, $paddr) or die "bind: $!";
    setsockopt SOCKET, SOL_SOCKET, SO_BROADCAST, 1;

    $| = 1;

    my $edaqs = {};

    my $hisiaddr = inet_aton("255.255.255.255") or die "unknown host";
    my $hispaddr = sockaddr_in($port, $hisiaddr);
    defined(send(SOCKET, "GET /serial", 0, $hispaddr)) or die "send bcast: $!" ;
    my $rin = '';
    vec($rin, fileno(SOCKET), 1) = 1;
    while ( select(my $rout = $rin, undef, undef, 1.0) ) {
        my $id = '';
        (my $hispaddr = recv(SOCKET, $id, 1600, 0)) or die "recv: $!" ;
        my ($port, $hisiaddr) = sockaddr_in($hispaddr);
        my $addr = inet_ntoa($hisiaddr);
        $edaqs->{$id} = $addr unless $hisiaddr eq $iaddr;
    }
    return $edaqs;
}

1;

