package SoMat::eDAQ::Hardware::VBM;

use strict;

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my ($expmod_devref, $cmd_port) = @_;
    my $self  = {};
    $self->{type} = "VBM";
    $self->{expmod} = $expmod_devref;
    $self->{port} = $cmd_port;  # default
    bless ($self, $class);
    return $self;
}

sub send_packet {
    my $self = shift;
    my ($packet) = @_;
#print STDERR "VBM sending $packet\n";
    return $self->{expmod}->send_packet($packet, $self->{port});
}

sub recv_cmd_response {
    my $self = shift;
    my $response = $self->{expmod}->recv_packet($self->{port});
#print STDERR "VBM recv_cmd_response got: $response\n";
    return $response;
}

sub run_command {
    my $self = shift;
    my ($command) = @_;
    $self->send_packet($command);
    my $response = $self->recv_cmd_response();
    if ($response =~ /^0\|(.*)$/) {
#print STDERR "VBM run_command got: $1\n";
        return $1;
    } else {
#print STDERR "VBM run_command got: undef\n";
        return undef;
    }
}

sub run_command_die {
    my $self = shift;
    my ($command) = @_;
    $self->send_packet($command);
    my $response = $self->recv_cmd_response();
    if ($response =~ /^0\|(.*)$/) {
        return $1;
    } else {
        die "$command failed: \"$response\"";
    }
}

1;
