package SoMat::eDAQ::TCE::File;

use strict;
require SoMat::eDAQ::SRam;
# require SoMat::File;
# require SoMat::eDAQ::Structurizer;

my $SRam;

sub sram {
    my ($class, $file, $symtype) = @_;
    my $s = bless {}, ref $class || $class;
    # Using global as a cache
    $SRam = SoMat::eDAQ::SRam->new('/dev/ramdisk', 'w') unless defined $SRam;
    $s->{sram} = $SRam;
    $s->{node} = $s->{sram}->get_rd_node($file);
    $s->{offset} = $s->{node}->{offset};
    die("Couldn't write $file: $!") unless $s->{node};
    $s->{szr} = $s->{sram}->{szr};
    $symtype = $s->{node}->{size} unless defined $symtype;
    $s->{symtype} = $symtype;
    $s->reread;
    return $s;
}

sub file {
    my ($class, $file, $symtype) = @_;
    my $s = bless {}, ref $class || $class;
    my $fh = SoMat::File->new($file, 0); # O_RDONLY KLUDGE
    $s->{szr} = SoMat::eDAQ::Structurizer->new($fh);
    $s->{offset} = 0;
    $symtype = -s $fh unless defined $symtype;
    $s->{symtype} = $symtype;
    $s->reread;
    return $s;
}

sub read {
    my $s = shift;
    return $s->{szr}->read(@_);
}

sub reread {
    my $s = shift;
    return $s->{szr}->read($s->{symtype}, $s->{offset});
}

sub write {
    my $s = shift;
    return $s->{szr}->write(@_);
}

sub get {
    my $s = shift;
    return $s->{szr}->get(@_);
}

sub put {
    my $s = shift;
    return $s->{szr}->put(@_);
}

1;
